## python3.14 3.14.0~b3

=== debian/changelog ===
python3.14 (3.14.0~b3-1) experimental; urgency=medium

  * Python 3.14.0 beta 3.
  * Refresh patches.
  * Extend gchead-alignment.diff to cover PyObject too. (Closes: #1105110)
  * Update symbols.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 18 Jun 2025 16:03:32 +0200

python3.14 (3.14.0~b2-1) experimental; urgency=medium

  * Python 3.14.0 beta 2.
    - Fixes CVE-2025-4516.
  * Replace m68k-alignment-fix.diff with a patch that reserves 2 bits for
    flags. (Closes: #1105110)
  * Refresh patches.
  * Update symbols.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 28 May 2025 00:27:57 +0200

python3.14 (3.14.0~b1-1) experimental; urgency=medium

  * Python 3.14.0 beta 1.
  * Bump watch file for python 3.14.
  * Drop PGP verification from watch file, upstream no longer PGP-signs
    releases (PEP-761), add a debian/rules target to perform sigstore
    verification.
  * Refresh patches.
  * Replace man-page-fixes.diff with the remaining outstanding upstream PR.
  * Drop patches no-wheel-whl.diff and shutil-which.patch, superseded
    upstream.
  * Build-Depend on libzstd-dev.
  * Add to python3.14-minimal: compression, _contextvars, _py_warnings, and
    _zstd.
  * Patch: Degrade traceback module gracefully without codeop in
    python3.14-minimal.
  * Update symbols.

 -- Stefano Rivera <stefanor@debian.org>  Fri, 09 May 2025 09:10:24 -0400

python3.14 (3.14.0~a7-1) experimental; urgency=medium

  * Python 3.14.0 alpha7.
  * Add to python-minimal: _ast_unparse, annotationlib.

 -- Matthias Klose <doko@debian.org>  Fri, 02 May 2025 15:56:09 +0200

python3.13 (3.13.3-3) UNRELEASED; urgency=medium

  * Update control.in for the changes in 3.13.3-2.
  * Replace no-wheel-whl.diff with upstream version.
  * Patch: Use shutil.which() in missing_compiler_executable().

 -- Stefano Rivera <stefanor@debian.org>  Sat, 12 Apr 2025 17:11:46 -0400

python3.13 (3.13.3-2) unstable; urgency=medium

  * Drop depends and test depends on python3-wheel-whl, setuptools has native
    bdist_wheel support.
  * Patch: Avoid needing python3-wheel-whl for the testsuite.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 10 Apr 2025 17:38:51 -0400

python3.13 (3.13.3-1) unstable; urgency=medium

  * Python 3.13.3.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 08 Apr 2025 15:55:40 -0400

python3.13 (3.13.2-3) unstable; urgency=medium

  * Update to the 3.13 branch 2025-03-29.
  * Editorial changes for the python man page (Bjarni Ingi Gislason).
    Closes: #1101406.
  * Update the min-tempfile patch for 3.13. Closes: #1098680.

 -- Matthias Klose <doko@debian.org>  Sat, 29 Mar 2025 11:04:43 +0100

python3.13 (3.13.2-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Replace update-manpage.patch with the version that landed upstream.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2025-03-13.
  * Generalize os testing in debian/rules (Samuel Thibault). Closes: #1095262.
  * Update sphinx build modules, still build with sphinx 8.1.x.
  * Bump standards version.

 -- Matthias Klose <doko@debian.org>  Thu, 13 Mar 2025 15:29:07 +0100

python3.13 (3.13.2-1) unstable; urgency=medium

  * Python 3.13.2.
  * Refresh patches.
  * Raise a more helpful ImportError in the turtle module. LP: #2093393.
  * Replace locale-module.patch with something to the change that landed
    upstream, and just missed 3.13.2.
  * Patch: update manpage, it has been neglected for a few releases.
    Closes: #1095052
  * Update symbols.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 04 Feb 2025 21:23:35 -0400

python3.13 (3.13.1-3) unstable; urgency=medium

  [ Stefano Rivera ]
  * Drop patch sysconfigdata-name.diff, upstream rejected it and we no longer
    need it.
  * Add compatibility symlink for old sysconfigdata name.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2025-01-03.
    - Fix issue #128030. Closes: #1090267.

 -- Matthias Klose <doko@debian.org>  Fri, 03 Jan 2025 11:26:34 +0100

python3.13 (3.13.1-2) unstable; urgency=medium

  * Update to the 3.13 branch 2024-12-12.
    - Fix issue #127655, CVE-2024-12254.
  * Add support for OpenSSL 3.4, issue #127330.
  * Mark test_structseq as failing on Ubuntu/armhf.

 -- Matthias Klose <doko@debian.org>  Thu, 12 Dec 2024 11:12:28 +0100

python3.13 (3.13.1-1) unstable; urgency=medium

  * Python 3.13.1.

  [ Matthias Klose ]
  * Apply temporary fix to fix build issue on m68k. Closes: #1087600.
  * Don't use -fno-inline-small-functions on hppa (Dave Anglin).
  * Build with -Os on sh4 (Adrian Glaubitz).
  * Stop using EXTRA_CFLAGS. Closes: #1087923.
  * Bump standards version.

  [ Stefano Rivera ]
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Wed, 04 Dec 2024 10:39:10 +0100

python3.13 (3.13.0-2) unstable; urgency=medium

  [ Stefano Rivera ]
  * Adjust lib-argparse.diff to avoid failing test_argparse's translation
    test.

  [ Matthias Klose ]
  * Update to the 3.13 branch 2024-11-12.
  * Refresh patches.

 -- Matthias Klose <doko@debian.org>  Tue, 12 Nov 2024 10:54:22 +0100

python3.13 (3.13.0-1) unstable; urgency=medium

  * Python 3.13.0 final.
  * Add DEP-12 metadata.
  * Update symbols file.
  * Patch: Allow stable API extensions to include a multiarch tuple in the
    filename.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 07 Oct 2024 14:58:50 -0700

python3.13 (3.13.0~rc3-1) unstable; urgency=medium

  * Python 3.13.0 release candidate 3.
  * Refresh patches.
  * Remove debian/locale-gen, we use locales-all. (Closes: #1076778)
  * Re-enable build-time tests. (Closes: #1076779)
    - Build-Depend on xvfb and xauth again.
    - Build-Depend on python3-{pip,setuptools,wheel}-whl for tests.
  * Verify upstream PGP signature.
  * Patch: Strip absolute --libdir paths from configure args in test_freeze.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 03 Oct 2024 09:12:35 -0600

python3.13 (3.13.0~rc2-1) unstable; urgency=medium

  * Python 3.13.0 release candidate 2.
  * Refresh patches.



=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk
include /usr/share/dpkg/pkg-info.mk

unexport LANG LC_ALL LC_CTYPE LC_COLLATE LC_TIME LC_NUMERIC LC_MESSAGES
unexport CFLAGS CXXFLAGS LDFLAGS CPPFLAGS

export SHELL = /bin/bash

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

ifeq ($(DEB_HOST_ARCH_OS),linux)
  PLAT = linux
else ifeq ($(DEB_HOST_ARCH_OS),kfreebsd)
  PLAT = gnukfreebsd10
else ifeq ($(DEB_HOST_ARCH_OS),hurd)
  PLAT = gnu0
else
  $(warning unhandled operating system name: $(DEB_HOST_ARCH_OS))
  PLAT = unknown
endif

SPHINXOPTS := -D today='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
SPHINXOPTS += -D html_last_updated_fmt='$(shell LC_ALL=C date -u +'%B %d, %Y' -d '@$(SOURCE_DATE_EPOCH)')'
export SPHINXOPTS

on_buildd := $(shell [ -f /CurrentlyBuilding -o "$$LOGNAME" = buildd -o "$$USER" = buildd ] && echo yes)

dh_compat2 := $(shell dpkg --compare-versions "$$(dpkg-query -f '$${Version}' -W debhelper)" lt 9.20150811ubuntu2 && echo DH_COMPAT=2)

ifneq (,$(findstring nocheck, $(DEB_BUILD_OPTIONS)))
  WITHOUT_CHECK := yes
endif
WITHOUT_BENCH :=
ifneq (,$(findstring nobench, $(DEB_BUILD_OPTIONS)))
  WITHOUT_BENCH := yes
endif
ifeq ($(on_buildd),yes)
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390)$(filter $(DEB_HOST_ARCH_OS), hurd kfreebsd))
    WITHOUT_CHECK := yes
  endif
  ifneq (,$(filter $(DEB_HOST_ARCH), armel hppa mips mipsel mips64 mips64el riscv64 s390)$(filter $(DEB_HOST_ARCH_OS), hurd kfreebsd))
    WITHOUT_BENCH := yes
  endif
endif
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  WITHOUT_BENCH := yes
  WITHOUT_CHECK := yes
endif

SPACE = $(EMPTY) $(EMPTY)
COMMA = ,
ifneq (,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
  NJOBS := -j $(subst parallel=,,$(filter parallel=%,$(subst $(COMMA), ,$(DEB_BUILD_OPTIONS))))
endif

distribution := $(shell lsb_release -is)
distrelease  := $(shell lsb_release -cs)
derivative      := $(shell \
	if dpkg-vendor --derives-from Ubuntu; then echo Ubuntu; \
	elif dpkg-vendor --derives-from Debian; then echo Debian; \
	else echo Unknown; fi)

# we inject our own lto flags
DPKG_OPTIMIZE = optimize=-lto
dpkg_buildflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)"dpkg-buildflags
ifeq (,$(filter $(distrelease),stretch buster bullseye trusty xenial bionic focal impish))
  with_nopie := yes
  dpkg_pieflags = DEB_BUILD_MAINT_OPTIONS="hardening=-pie $(DPKG_OPTIMIZE)" dpkg-buildflags
endif

# FIXME: remove sid when uploading to unstable, after bookworm is released
#ifneq (,$(filter $(distrelase), jessie stretch buster bullseye bookworm sid precise trusty xenial bionic focal groovy hirsute))
  with_dbmmodule = yes
  bd_dbm = libdb-dev
  dbmliborder = bdb:gdbm
#else
#  bd_dbm = libgdbm-compat-dev
#  dbmliborder = gdbm:bdb
#endif

ifneq (,$(filter valgrind, $(shell dpkg-query --show -f '$${Depends}\n' valgrind-if-available)))
  valgrind_configure_args = --with-valgrind
endif

VER=3.14
SVER=3.14.0~b1
NVER=3.15
PVER=python$(VER)
EXT_VER=$(subst .,,$(VER))
PRIORITY=$(shell echo $(VER) | tr -d '.')0

PREVVER	:= $(shell awk '/^python/ && NR > 1 {print substr($$2,2,length($$2)-2); exit}' debian/changelog)

# default versions are built from the python-defaults source package
# keep the definition to adjust package priorities.
DEFAULT_VERSION = no
STATIC_PYTHON=yes

MIN_MODS := $(shell awk '/^  / && $$2 == "module" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_EXTS := $(shell awk '/^  / && $$2 ~ /^extension/ { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_BUILTINS := $(shell awk '/^  / && $$2 == "builtin" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_PACKAGES := $(shell awk '/^  / && $$2 == "package" { print $$1 }' \
		debian/PVER-minimal.README.Debian.in)
MIN_ENCODINGS := $(foreach i, \
			$(filter-out \
			  big5% bz2% cp932.py cp949.py cp950.py euc_% \
			  gb% iso2022% johab.py shift_jis% , \
			  $(shell cd Lib/encodings && echo *.py)), \
			encodings/$(i)) \
		 codecs.py stringprep.py

with_tk := yes
with_gdbm := yes
with_interp := static
#with_interp := shared

PY_INTERPRETER = /usr/bin/python$(VER)

ifeq ($(DEFAULT_VERSION),yes)
  PY_PRIO = standard
  #PYSTDDEP = , python (>= $(VER))
else
  PY_PRIO = optional
endif
ifeq ($(distribution),Ubuntu)
  PY_MINPRIO = required
  PY_MINPRIO = optional
  #with_udeb = yes
  # test_ssl assumes that openssl is compiled with security level set to 1
  # make it so, during the build
  export OPENSSL_CONF = $(CURDIR)/debian/openssl.cnf
else
  PY_MINPRIO = $(PY_PRIO)
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  bd_qual = :any
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric))
  ma_filter = cat
else
  ma_filter = grep -v '^Multi-Arch:'
endif
ifeq (,$(filter $(distrelease),lenny etch squeeze wheezy lucid maverick natty oneiric precise quantal raring saucy trusty))
  bd_dpkgdev = dpkg-dev (>= 1.17.11),
endif

CC=$(DEB_HOST_GNU_TYPE)-gcc
CXX=$(DEB_HOST_GNU_TYPE)-g++
ifneq (,$(filter $(distrelease),bionic))
  CC=$(DEB_HOST_GNU_TYPE)-gcc-8
  CXX=$(DEB_HOST_GNU_TYPE)-g++-8
  bd_gcc = g++-8,
endif

AR=$(DEB_HOST_GNU_TYPE)-ar
RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib

# configure and dtrace consume these
export CC CXX

# These variables are needed for the ELF package metadata (set via LDFLAGS)
DEB_BUILD_OS_RELEASE_ID=$(shell . /usr/lib/os-release && echo $$ID)
export DEB_BUILD_OS_RELEASE_ID
export DEB_HOST_ARCH
export DEB_SOURCE
export DEB_VERSION

DPKG_CPPFLAGS= $(shell $(dpkg_buildflags) --get CPPFLAGS)
DPKG_CFLAGS  := $(shell $(dpkg_buildflags) --get CFLAGS)
DPKG_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_CFLAGS))
DPKG_LDFLAGS = $(shell $(dpkg_buildflags) --get LDFLAGS)
OPT_CFLAGS   := $(filter-out -O%,$(DPKG_CFLAGS)) # default is -O3
DEBUG_CFLAGS := $(patsubst -O%,-Og,$(DPKG_CFLAGS))

DPKG_PIE_CPPFLAGS= $(shell $(dpkg_pieflags) --get CPPFLAGS)
DPKG_PIE_CFLAGS  := $(shell $(dpkg_pieflags) --get CFLAGS)
DPKG_PIE_CFLAGS  := $(subst -fstack-protector-strong,-fstack-protector,$(DPKG_PIE_CFLAGS))
DPKG_PIE_LDFLAGS = $(shell $(dpkg_pieflags) --get LDFLAGS)
OPT_PIE_CFLAGS   := $(filter-out -O%,$(DPKG_PIE_CFLAGS)) # default is -O3

ifeq ($(DEB_HOST_ARCH),ia64)
    DPKG_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
    DPKG_PIE_CPPFLAGS += -DWITH_PYMALLOC_RADIX_TREE=0
endif
# see https://gcc.gnu.org/PR81426
ifneq (,$(filter $(DEB_HOST_ARCH), sh4))
    OPT_CFLAGS += $(filter-out -O%,$(DPKG_CFLAGS)) -Os
    OPT_PIE_CFLAGS += $(filter-out -O%,$(DPKG_PIE_CFLAGS)) -Os
endif
ifneq (,$(filter $(DEB_HOST_ARCH), ppc64 ppc64el))
    OPT_CFLAGS += -fexceptions
    OPT_PIE_CFLAGS += -fexceptions
    DEBUG_CFLAGS += -fexceptions
endif

ifeq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
  ifeq ($(DEB_HOST_ARCH_OS),linux)
    ifneq (,$(findstring $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
      with_pgo := yes
    endif
  endif
endif

ifneq (,$(filter $(DEB_HOST_ARCH), amd64 armel armhf arm64 i386 powerpc ppc64 ppc64el s390x))
  with_lto := yes
endif

ifneq (,$(findstring nopgo, $(DEB_BUILD_OPTIONS)))
  with_pgo :=
endif

ifneq (,$(findstring nolto, $(DEB_BUILD_OPTIONS)))
  with_lto :=
endif

ifneq (,$(findstring noopt, $(DEB_BUILD_OPTIONS)))
    OPT_CFLAGS := $(filter-out -O%, $(OPT_CFLAGS)) -O0
    with_pgo =
    with_lto =
endif

BASE_LTO_CFLAGS = -g -fwrapv -O3
ifeq ($(with_lto),yes)
    LTO_CFLAGS = $(BASE_LTO_CFLAGS) -flto -fuse-linker-plugin
    with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
    ifeq ($(with_fat_lto),yes)
      LTO_CFLAGS += -ffat-lto-objects
    endif
    OPT_CFLAGS += $(LTO_CFLAGS)
    OPT_PIE_CFLAGS += $(LTO_CFLAGS)
    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
endif

## python3.14 3.14.0~rc1

=== debian/changelog ===
python3.14 (3.14.0~rc1-1) experimental; urgency=medium

  * Python 3.14.0 release candidate 1.
  * Refresh patches.
  * Add symbols.

 -- Stefano Rivera <stefanor@debian.org>  Wed, 23 Jul 2025 13:16:56 +0200

python3.14 (3.14.0~b4-1) experimental; urgency=medium

  * Python 3.14.0 beta 4.
  * Enable deterministic LTO output (Closes: #1105119)

 -- Stefano Rivera <stefanor@debian.org>  Tue, 08 Jul 2025 19:29:09 +0200

## python3.14 3.14.0~rc2

=== debian/changelog ===
python3.14 (3.14.0~rc2-1) experimental; urgency=medium

  * Python 3.14.0 release candidate 2.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 21 Aug 2025 15:42:53 +0200

=== debian/rules ===
--- 
+++ 
@@ -87,7 +87,7 @@
 endif
 
 VER=3.14
-SVER=3.14.0~b1
+SVER=3.14.0~rc1
 NVER=3.15
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
@@ -232,11 +232,8 @@
     with_fat_lto := $(shell dpkg --compare-versions $$($(CC) --version \
 			| sed -n '/^$(CC)/s,.* ,,p') ge 4.9 && echo yes)
     ifeq ($(with_fat_lto),yes)
-      LTO_CFLAGS += -ffat-lto-objects
+      LTO_CFLAGS += -ffat-lto-objects -frandom-seed=$(DEB_VERSION)
     endif
     OPT_CFLAGS += $(LTO_CFLAGS)
     OPT_PIE_CFLAGS += $(LTO_CFLAGS)
     AR=$(DEB_HOST_GNU_TYPE)-gcc-ar
-    RANLIB=$(DEB_HOST_GNU_TYPE)-gcc-ranlib
-endif
-

## python3.14 3.14.0~rc3

=== debian/changelog ===
python3.14 (3.14.0~rc3-1) unstable; urgency=medium

  * Python 3.14.0 release candidate 3.
  * Upload to unstable.

 -- Stefano Rivera <stefanor@debian.org>  Thu, 18 Sep 2025 14:47:19 +0200

=== debian/rules ===
--- 
+++ 
@@ -87,7 +87,7 @@
 endif
 
 VER=3.14
-SVER=3.14.0~rc1
+SVER=3.14.0~rc3
 NVER=3.15
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))

## python3.14 3.14.0

=== Doc/Makefile ===
#
# Makefile for Python documentation
# ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
#

# You can set these variables from the command line.
PYTHON       = python3
VENVDIR      = ./venv
UV           = uv
SPHINXBUILD  = PATH=$(VENVDIR)/bin:$$PATH sphinx-build
BLURB        = PATH=$(VENVDIR)/bin:$$PATH blurb
JOBS         = auto
PAPER        =
SOURCES      =
DISTVERSION  = $(shell $(PYTHON) tools/extensions/patchlevel.py)
REQUIREMENTS = requirements.txt
SPHINXERRORHANDLING = --fail-on-warning

# Internal variables.
PAPEROPT_a4     = --define latex_elements.papersize=a4paper
PAPEROPT_letter = --define latex_elements.papersize=letterpaper

ALLSPHINXOPTS = --builder $(BUILDER) \
                --doctree-dir build/doctrees \
                --jobs $(JOBS) \
                $(PAPEROPT_$(PAPER)) \
                $(SPHINXOPTS) $(SPHINXERRORHANDLING) \
                . build/$(BUILDER) $(SOURCES)

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  clean      to remove build files"
	@echo "  venv       to create a venv with necessary tools"
	@echo "  html       to make standalone HTML files"
	@echo "  gettext    to generate POT files"
	@echo "  htmlview   to open the index page built by the html target in your browser"
	@echo "  htmllive   to rebuild and reload HTML files in your browser"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  text       to make plain text files"
	@echo "  texinfo    to make Texinfo file"
	@echo "  epub       to make EPUB files"
	@echo "  changes    to make an overview over all changed/added/deprecated items"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  coverage   to check documentation coverage for library and C API"
	@echo "  doctest    to run doctests in the documentation"
	@echo "  pydoc-topics  to regenerate the pydoc topics file"
	@echo "  dist       to create a \"dist\" directory with archived docs for download"
	@echo "  check      to run a check for frequent markup errors"

.PHONY: build
build:
	-mkdir -p build
# Look first for a Misc/NEWS file (building from a source release tarball
# or old repo) and use that, otherwise look for a Misc/NEWS.d directory
# (building from a newer repo) and use blurb to generate the NEWS file.
	@if [ -f  ../Misc/NEWS ] ; then \
		echo "Using existing Misc/NEWS file"; \
		cp ../Misc/NEWS build/NEWS; \
	elif $(BLURB) help >/dev/null 2>&1 && $(SPHINXBUILD) --version >/dev/null 2>&1; then \
		if [ -d ../Misc/NEWS.d ]; then \
			echo "Building NEWS from Misc/NEWS.d with blurb"; \
			$(BLURB) merge -f build/NEWS; \
		else \
			echo "Neither Misc/NEWS.d nor Misc/NEWS found; cannot build docs"; \
			exit 1; \
		fi \
	else \
		echo ""; \
		echo "Missing the required blurb or sphinx-build tools."; \
		echo "Please run 'make venv' to install local copies."; \
		echo ""; \
		exit 1; \
	fi
	$(SPHINXBUILD) $(ALLSPHINXOPTS)
	@echo

.PHONY: html
html: BUILDER = html
html: build
	@echo "Build finished. The HTML pages are in build/html."

.PHONY: htmlhelp
htmlhelp: BUILDER = htmlhelp
htmlhelp: build
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      "build/htmlhelp/pydoc.hhp project file."

.PHONY: latex
latex: BUILDER = latex
latex: build
	@echo "Build finished; the LaTeX files are in build/latex."
	@echo "Run \`make all-pdf' or \`make all-ps' in that directory to" \
	      "run these through (pdf)latex."

.PHONY: text
text: BUILDER = text
text: build
	@echo "Build finished; the text files are in build/text."

.PHONY: texinfo
texinfo: BUILDER = texinfo
texinfo: build
	@echo "Build finished; the python.texi file is in build/texinfo."
	@echo "Run \`make info' in that directory to run it through makeinfo."

.PHONY: epub
epub: BUILDER = epub
epub: build
	@echo "Build finished; the epub files are in build/epub."

.PHONY: changes
changes: BUILDER = changes
changes: build
	@echo "The overview file is in build/changes."

.PHONY: linkcheck
linkcheck: BUILDER = linkcheck
linkcheck:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Link check complete; look for any errors in the above output" \
	     "or in build/$(BUILDER)/output.txt"; \
	false; }

.PHONY: coverage
coverage: BUILDER = coverage
coverage: build
	@echo "Coverage finished; see c.txt and python.txt in build/coverage"

.PHONY: doctest
doctest: BUILDER = doctest
doctest:
	@$(MAKE) build BUILDER=$(BUILDER) || { \
	echo "Testing of doctests in the sources finished, look at the" \
	     "results in build/doctest/output.txt"; \
	false; }

.PHONY: pydoc-topics
pydoc-topics: BUILDER = pydoc-topics
pydoc-topics: build
	@echo "Building finished; now run this:" \
	      "cp build/pydoc-topics/topics.py ../Lib/pydoc_data/topics.py"

.PHONY: gettext
gettext: BUILDER = gettext
gettext: override SPHINXOPTS := --doctree-dir build/doctrees-gettext $(SPHINXOPTS)
gettext: build

.PHONY: htmlview
htmlview: html
	$(PYTHON) -c "import os, webbrowser; webbrowser.open('file://' + os.path.realpath('build/html/index.html'))"

.PHONY: htmllive
htmllive: SPHINXBUILD = PATH=$(VENVDIR)/bin:$$PATH sphinx-autobuild
htmllive: SPHINXOPTS = --re-ignore="/venv/" --open-browser --delay 0
htmllive: _ensure-sphinx-autobuild html

.PHONY: clean
clean: clean-venv
	-rm -rf build/*

.PHONY: clean-venv
clean-venv:
	rm -rf $(VENVDIR)

.PHONY: venv
venv:
	@if [ -d $(VENVDIR) ] ; then \
		echo "venv already exists."; \
		echo "To recreate it, remove it first with \`make clean-venv'."; \
	else \
		set -e; \
		echo "Creating venv in $(VENVDIR)"; \
		if $(UV) --version >/dev/null 2>&1; then \
			$(UV) venv --python=$(PYTHON) $(VENVDIR); \
			VIRTUAL_ENV=$(VENVDIR) $(UV) pip install -r $(REQUIREMENTS); \
		else \
			$(PYTHON) -m venv $(VENVDIR); \
			$(VENVDIR)/bin/python3 -m pip install --upgrade pip; \
			$(VENVDIR)/bin/python3 -m pip install -r $(REQUIREMENTS); \
		fi; \
		echo "The venv has been created in the $(VENVDIR) directory"; \
	fi

.PHONY: dist-no-html
dist-no-html: dist-text dist-pdf dist-epub dist-texinfo

.PHONY: dist
dist:
	rm -rf dist
	mkdir -p dist
	$(MAKE) dist-html
	$(MAKE) dist-text
	$(MAKE) dist-pdf
	$(MAKE) dist-epub
	$(MAKE) dist-texinfo

.PHONY: dist-html
dist-html:
	# archive the HTML
	@echo "Building HTML..."
	mkdir -p dist
	rm -rf build/html
	find dist -name 'python-$(DISTVERSION)-docs-html*' -exec rm -rf {} \;
	$(MAKE) html
	cp -pPR build/html dist/python-$(DISTVERSION)-docs-html
	rm -rf dist/python-$(DISTVERSION)-docs-html/_images/social_previews/
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-html.tar python-$(DISTVERSION)-docs-html
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-html.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-html.zip python-$(DISTVERSION)-docs-html)
	rm -r dist/python-$(DISTVERSION)-docs-html
	rm dist/python-$(DISTVERSION)-docs-html.tar
	@echo "Build finished and archived!"

.PHONY: dist-text
dist-text:
	# archive the text build
	@echo "Building text..."
	mkdir -p dist
	rm -rf build/text
	find dist -name 'python-$(DISTVERSION)-docs-text*' -exec rm -rf {} \;
	$(MAKE) text
	cp -pPR build/text dist/python-$(DISTVERSION)-docs-text
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-text.tar python-$(DISTVERSION)-docs-text
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-text.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-text.zip python-$(DISTVERSION)-docs-text)
	rm -r dist/python-$(DISTVERSION)-docs-text
	rm dist/python-$(DISTVERSION)-docs-text.tar
	@echo "Build finished and archived!"

.PHONY: dist-pdf
dist-pdf:
	# archive the A4 latex
	@echo "Building LaTeX (A4 paper)..."
	mkdir -p dist
	rm -rf build/latex
	find dist -name 'python-$(DISTVERSION)-docs-pdf*' -exec rm -rf {} \;
	$(MAKE) latex PAPER=a4
	# remove zip & bz2 dependency on all-pdf,
	# as otherwise the full latexmk process is run twice.
	# ($$ is needed to escape the $; https://www.gnu.org/software/make/manual/make.html#Basics-of-Variable-References)
	-sed -i 's/: all-$$(FMT)/:/' build/latex/Makefile
	(cd build/latex; $(MAKE) clean && $(MAKE) --jobs=$$((`nproc`+1)) --output-sync LATEXMKOPTS='-quiet' all-pdf && $(MAKE) FMT=pdf zip bz2)
	cp build/latex/docs-pdf.zip dist/python-$(DISTVERSION)-docs-pdf-a4.zip
	cp build/latex/docs-pdf.tar.bz2 dist/python-$(DISTVERSION)-docs-pdf-a4.tar.bz2
	@echo "Build finished and archived!"

.PHONY: dist-epub
dist-epub:
	# copy the epub build
	@echo "Building EPUB..."
	mkdir -p dist
	rm -rf build/epub
	rm -f dist/python-$(DISTVERSION)-docs.epub
	$(MAKE) epub
	cp -pPR build/epub/Python.epub dist/python-$(DISTVERSION)-docs.epub
	@echo "Build finished and archived!"

.PHONY: dist-texinfo
dist-texinfo:
	# archive the texinfo build
	@echo "Building Texinfo..."
	mkdir -p dist
	rm -rf build/texinfo
	find dist -name 'python-$(DISTVERSION)-docs-texinfo*' -exec rm -rf {} \;
	$(MAKE) texinfo
	$(MAKE) info --directory=build/texinfo
	cp -pPR build/texinfo dist/python-$(DISTVERSION)-docs-texinfo
	tar -C dist -cf dist/python-$(DISTVERSION)-docs-texinfo.tar python-$(DISTVERSION)-docs-texinfo
	bzip2 -9 -k dist/python-$(DISTVERSION)-docs-texinfo.tar
	(cd dist; zip -q -r -9 python-$(DISTVERSION)-docs-texinfo.zip python-$(DISTVERSION)-docs-texinfo)
	rm -r dist/python-$(DISTVERSION)-docs-texinfo
	rm dist/python-$(DISTVERSION)-docs-texinfo.tar
	@echo "Build finished and archived!"

.PHONY: _ensure-package
_ensure-package: venv
	if $(UV) --version >/dev/null 2>&1; then \
		VIRTUAL_ENV=$(VENVDIR) $(UV) pip install $(PACKAGE); \
	else \
		$(VENVDIR)/bin/python3 -m pip install $(PACKAGE); \
	fi

.PHONY: _ensure-pre-commit
_ensure-pre-commit:
	$(MAKE) _ensure-package PACKAGE=pre-commit

.PHONY: _ensure-sphinx-autobuild
_ensure-sphinx-autobuild:
	$(MAKE) _ensure-package PACKAGE=sphinx-autobuild

.PHONY: check
check: _ensure-pre-commit
	$(VENVDIR)/bin/python3 -m pre_commit run --all-files

.PHONY: serve
serve:
	@echo "The serve target was removed, use htmllive instead (see gh-80510)"

# Targets for daily automated doc build
# By default, Sphinx only rebuilds pages where the page content has changed.
# This means it doesn't always pick up changes to preferred link targets, etc
# To ensure such changes are picked up, we build the published docs with
# ``--fresh-env`` (to ignore the cached environment) and ``--write-all``
# (to ignore already existing output files)

# for development releases: always build
.PHONY: autobuild-dev
autobuild-dev: DISTVERSION = $(shell $(PYTHON) tools/extensions/patchlevel.py --short)
autobuild-dev:
	$(MAKE) dist-no-html SPHINXOPTS='$(SPHINXOPTS) --fresh-env --write-all --html-define daily=1' DISTVERSION=$(DISTVERSION)

# for HTML-only rebuilds
.PHONY: autobuild-dev-html
autobuild-dev-html: DISTVERSION = $(shell $(PYTHON) tools/extensions/patchlevel.py --short)
autobuild-dev-html:
	$(MAKE) dist-html SPHINXOPTS='$(SPHINXOPTS) --fresh-env --write-all --html-define daily=1' DISTVERSION=$(DISTVERSION)

# for stable releases: only build if not in pre-release stage (alpha, beta)
# release candidate downloads are okay, since the stable tree can be in that stage
.PHONY: autobuild-stable
autobuild-stable:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@$(MAKE) autobuild-dev

.PHONY: autobuild-stable-html
autobuild-stable-html:
	@case $(DISTVERSION) in *[ab]*) \
		echo "Not building; $(DISTVERSION) is not a release version."; \
		exit 1;; \
	esac
	@$(MAKE) autobuild-dev-html

=== Doc/requirements.txt ===
# Requirements to build the Python documentation
#
# Note that when updating this file, you will likely also have to update
# the Doc/constraints.txt file.

# The Sphinx version is pinned so that new versions that introduce new warnings
# won't suddenly cause build failures. Updating the version is fine as long
# as no warnings are raised by doing so.
# Keep this version in sync with ``Doc/conf.py``.
sphinx~=8.2.0

blurb

sphinxext-opengraph~=0.12.0
sphinx-notfound-page~=1.0.0

# The theme used by the documentation is stored separately, so we need
# to install that as well.
python-docs-theme>=2023.3.1,!=2023.7

-c constraints.txt

=== Android/testbed/app/src/main/c/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4.1)
project(testbed)

# Resolve variables from the command line.
string(
    REPLACE {{triplet}} ${CMAKE_LIBRARY_ARCHITECTURE}
    PYTHON_PREFIX_DIR ${PYTHON_PREFIX_DIR}
)

include_directories(${PYTHON_PREFIX_DIR}/include/python${PYTHON_VERSION})
link_directories(${PYTHON_PREFIX_DIR}/lib)
link_libraries(log python${PYTHON_VERSION})

add_library(main_activity SHARED main_activity.c)

=== debian/changelog ===
python3.14 (3.14.0-4) unstable; urgency=medium

  * Update min-tempfile patch for 3.14 (LP: #2127898).
  * Remove an unnecessary hunk from min-ntpath-import.diff.
  * Reorganize -minimal patches consistently by missing module name.
  * Patch: Shim gettext imports in getopt and optparse. (LP: #2127899)
  * Patch: Shim shutil import in zipfile. (LP: #2127900)
  * Use Debian's default LLVM version.
    - Patch: Allow specifying the LLVM version.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 21 Oct 2025 13:23:27 +0200

python3.14 (3.14.0-3) unstable; urgency=medium

  * Support docutils 0.22. (Closes: #1118327)
  * Enable the experimental JIT on amd64 and arm64. It's disabled at runtime
    by default, to enable it set the environment variable PYTHON_JIT=1.
  * Patch: m68k: Avoid SIGILL when built with GCC 15.
    - Revert the use of GCC 14 for m68k.
  * Patch: CVE-2025-8291: Check consistency of the zip64 end of central
    directory record.

 -- Stefano Rivera <stefanor@debian.org>  Mon, 20 Oct 2025 10:37:05 +0200

python3.14 (3.14.0-2) unstable; urgency=medium

  * Preliminary patch for stack grows up (Dave Anglin). Closes: #1105111.
  * Build using GCC 14 on m68k. See PR target/122211.

 -- Matthias Klose <doko@debian.org>  Thu, 09 Oct 2025 08:26:09 +0200

python3.14 (3.14.0-1) unstable; urgency=medium

  * Python 3.14.0 final.
  * Refresh patches.

 -- Stefano Rivera <stefanor@debian.org>  Tue, 07 Oct 2025 16:35:05 +0200

=== debian/control ===
Source: python3.14
Section: python
Priority: optional
Maintainer: Matthias Klose <doko@debian.org>
Uploaders: Stefano Rivera <stefanor@debian.org>
Build-Depends: debhelper (>= 11), dpkg-dev (>= 1.17.11),
  quilt, autoconf,
  lsb-release, sharutils,
  libreadline-dev | libeditreadline-dev, libncurses-dev, 
  zlib1g-dev, libbz2-dev, liblzma-dev, libzstd-dev,
  libgdbm-dev, libdb-dev,
  tk-dev, blt-dev (>= 2.4z),
  libssl-dev,
  libexpat1-dev,
  libbluetooth-dev [linux-any] <!pkg.python3.14.nobluetooth>,
  locales-all,
  libnsl-dev,
  libsqlite3-dev, libffi-dev (>= 3.0.5) [!or1k],
  libgpm2 [linux-any],
  media-types | mime-support, netbase, bzip2, time, python3:any, python3.14:any <cross>,
  net-tools,
  python3-pip-whl <!nocheck>,
  python3-setuptools-whl (>= 70.1) <!nocheck>,
  xvfb <!nocheck>, xauth <!nocheck>,
  tzdata <!nocheck>,
  systemtap-sdt-dev [!hurd-amd64 !hurd-i386],
  valgrind-if-available,
  clang [amd64 arm64],
  llvm [amd64 arm64],
Build-Depends-Indep: python3-sphinx (>= 8.2),
  python3-sphinx-notfound-page,
  python3-sphinxext-opengraph,
   python3-docs-theme, texinfo
Standards-Version: 4.7.2
Vcs-Browser: https://salsa.debian.org/cpython-team/python3
Vcs-Git: https://salsa.debian.org/cpython-team/python3.git
XS-Testsuite: autopkgtest

Package: python3.14
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.14-minimal (= ${binary:Version}),
 libpython3.14-stdlib (= ${binary:Version}),
 media-types | mime-support, tzdata,
 ${shlibs:Depends}, ${misc:Depends}
Recommends: ca-certificates
Suggests: python3.14-venv, python3.14-doc, binutils
Breaks: python3-all (<< 3.6.5~rc1-1),
  python3-dev (<< 3.6.5~rc1-1),
  python3-venv (<< 3.6.5-2)
Description: Interactive high-level object-oriented language (version 3.14)
 Python is a high-level, interactive, object-oriented language. Its 3.14 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.

Package: python3.14-venv
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.14 (= ${binary:Version}),
 python3-pip-whl (>= 22.2),
 python3-setuptools-whl (>= 70.1),
 ${shlibs:Depends}, ${misc:Depends},
Breaks: python3-pip (<< 1.5.6-4)
Description: Interactive high-level object-oriented language (pyvenv binary, version 3.14)
 Python is a high-level, interactive, object-oriented language. Its 3.14 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the pyvenv-3.14 binary.

Package: libpython3.14-stdlib
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.14-minimal (= ${binary:Version}),
  media-types | mime-support, netbase, tzdata,
  ${shlibs:Depends}, ${misc:Depends}
Description: Interactive high-level object-oriented language (standard library, version 3.14)
 Python is a high-level, interactive, object-oriented language. Its 3.14 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains Python 3.14's standard library. It is normally not
 used on its own, but as a dependency of python3.14.

Package: python3.14-minimal
Architecture: any
Multi-Arch: allowed
Priority: optional
Pre-Depends: ${shlibs:Pre-Depends}
Depends: libpython3.14-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.14
Suggests: binfmt-support
Conflicts: binfmt-support (<< 1.1.2)
Description: Minimal subset of the Python language (version 3.14)
 This package contains the interpreter and some essential modules.  It can
 be used in the boot process for some basic tasks.
 See /usr/share/doc/python3.14-minimal/README.Debian for a list of the modules
 contained in this package.
XB-Cnf-Visible-Pkgname: python3.14

Package: python3.14-nopie
Architecture: any
Multi-Arch: allowed
Priority: optional
Depends: python3.14-minimal (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Python interpreter linked without PIE (version 3.14)
 This package contains the interpreter not built as position independent
 executable. This interpreter is diverting the python3.14 executable, and making
 the interpreter built with PIE available as python3.14-pie.
XB-Cnf-Visible-Pkgname: python3.14

Package: libpython3.14-minimal
Architecture: any
Multi-Arch: same
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: libpython3.14-stdlib
Conflicts: binfmt-support (<< 1.1.2)
Breaks: libpython3.14-stdlib (<< 3.13.1-3~)
Replaces: libpython3.14-stdlib (<< 3.13.1-3~)
Description: Minimal subset of the Python language (version 3.14)
 This package contains some essential modules. It is normally not
 used on it's own, but as a dependency of python3.14-minimal.

Package: libpython3.14
Replaces: libpython3.14
Architecture: any
Multi-Arch: same
Section: libs
Priority: optional
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.14-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Shared Python runtime library (version 3.14)
 Python is a high-level, interactive, object-oriented language. Its 3.14 version
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package contains the shared runtime library, normally not needed
 for programs using the statically linked interpreter.

Package: python3.14-examples
Architecture: all
Depends: python3.14:any (>= ${source:Version}), ${misc:Depends}
Description: Examples for the Python language (v3.14)
 Examples, Demos and Tools for Python (v3.14). These are files included in
 the upstream Python distribution (v3.14).

Package: python3.14-dev
Architecture: any
Multi-Arch: allowed
Depends: python3.14 (= ${binary:Version}),
  libpython3.14-dev (= ${binary:Version}),
  libpython3.14 (= ${binary:Version}),
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.14)
 Header files, a static library and development tools for building
 Python (v3.14) modules, extending the Python interpreter or embedding
 Python (v3.14) in applications.
 .
 Maintainers of Python packages should read README.maintainers.

Package: libpython3.14-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.14-stdlib (= ${binary:Version}),
  libpython3.14 (= ${binary:Version}),
  libexpat1-dev, zlib1g-dev,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: libc6-dev | libc-dev
Description: Header files and a static library for Python (v3.14)
 Header files, a static library and development tools for building
 Python (v3.14) modules, extending the Python interpreter or embedding
 Python (v3.14) in applications.
 .
 Maintainers of Python packages should read README.maintainers.
 .
 This package contains development files. It is normally not
 used on it's own, but as a dependency of python3.14-dev.

Package: libpython3.14-testsuite
Section: libdevel
Architecture: all
Depends: python3.14 (>= ${binary:Version}), ${misc:Depends}, net-tools
Suggests: python3-gdbm, python3-tk
Description: Testsuite for the Python standard library (v3.14)
 The complete testsuite for the Python standard library.  Note that
 a subset is found in the libpython3.14-stdlib package, which should
 be enough for other packages to use (please do not build-depend
 on this package, but file a bug report to include additional 
 testsuite files in the libpython3.14-stdlib package).

Package: idle-python3.14
Architecture: all
Depends: python3.14, python3-tk, python3.14-tk,
  ${misc:Depends},
  libjs-mathjax,
Enhances: python3.14
Description: IDE for Python (v3.14) using Tkinter
 IDLE is an Integrated Development Environment for Python (v3.14).
 IDLE is written using Tkinter and therefore quite platform-independent.

Package: python3.14-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends: libjs-jquery, libjs-underscore, ${misc:Depends}
Suggests: python3.14
Description: Documentation for the high-level object-oriented language Python (v3.14)
 These is the official set of documentation for the interactive high-level
 object-oriented language Python (v3.14). All documents are provided
 in HTML format. The package consists of ten documents:
 .
   * What's New in Python3.14
   * Tutorial
   * Python Library Reference
   * Macintosh Module Reference
   * Python Language Reference
   * Extending and Embedding Python
   * Python/C API Reference
   * Installing Python Modules
   * Documenting Python
   * Distributing Python Modules

Package: python3.14-dbg
Section: debug
Architecture: any
Multi-Arch: allowed
Depends: python3.14 (= ${binary:Version}), libpython3.14-dbg (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Recommends: gdb
Suggests: python3-gdbm-dbg, python3-tk-dbg
Description: Debug Build of the Python Interpreter (version 3.14)
 The package holds two things:
 .
 - A Python interpreter configured with --pydebug. Dynamically loaded modules
   are searched as <foo>_d.so first. Third party extensions need a separate
   build to be used by this interpreter.
 - Debug information for standard python interpreter and extensions.
 .
 See the README.debug for more information.

Package: libpython3.14-dbg
Section: debug
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: libpython3.14-stdlib (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Breaks: libpython3.14-dbg (<< ${source:Version}),
  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
Replaces: libpython3.14-dbg,
  python3-gdbm-dbg (<< 3.12.5-2~), python3-tk-dbg (<< 3.12.5-2~)
Description: Debug Build of the Python Interpreter (version 3.14)
 The package holds two things:
 .
 - Extensions for a Python interpreter configured with --pydebug.
 - Debug information for standard python extensions.
 .
 See the README.debug for more information.

Package: python3.14-full
Architecture: any
Multi-Arch: allowed
Depends: python3.14 (= ${binary:Version}),
  libpython3.14-testsuite,
  python3.14-venv (= ${binary:Version}),
  idle-python3.14,
  python3.14-gdbm,
  python3.14-tk,
  ca-certificates,
  ${shlibs:Depends}, ${misc:Depends}
Recommends: python3.14-doc, python3.14-examples,
Suggests: python3.14-dev
Description: Python Interpreter with complete class library (version 3.14)
 Python, the high-level, interactive object oriented language,
 includes an extensive class library with lots of goodies for
 network programming, system administration, sounds and graphics.
 .
 This package is a dependency package, which depends on the full
 standard library of Python for Python developers. Including modules
 used only at build-time, such as venv, and modules with complex
 dependencies, such as tk and IDLE. All batteries included.
 .
 According to the Debian Python policy, this package must not be used in
 build dependencies, dependencies and recommendations.

Package: python3.14-tk
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: python3.14
Suggests: tix
Breaks: python3-tk (<< 3.12.5-2~)
Replaces: python3-tk (<< 3.12.5-2~)
XB-Python-Version: 3.14
Description: Tkinter - Writing Tk applications with Python (v3.14)
 A module for writing portable GUI applications with Python (v3.14) using Tk.
 Also known as Tkinter.

Package: python3.14-gdbm
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Enhances: python3.14
Breaks: python3-gdbm (<< 3.12.5-2~)
Replaces: python3-gdbm (<< 3.12.5-2~)
Description: GNU dbm database support for Python (v3.14)
 GNU dbm database module for Python. Install this if you want to
 create or read GNU dbm database files with Python.

=== debian/rules ===
--- 
+++ 
@@ -87,7 +87,7 @@
 endif
 
 VER=3.14
-SVER=3.14.0~rc3
+SVER=3.14.0
 NVER=3.15
 PVER=python$(VER)
 EXT_VER=$(subst .,,$(VER))
@@ -161,6 +161,7 @@
 
 AR=$(DEB_HOST_GNU_TYPE)-ar
 RANLIB=$(DEB_HOST_GNU_TYPE)-ranlib
+LLVM_VERSION=$(firstword $(subst ., ,$(shell llvm-config --version)))
 
 # configure and dtrace consume these
 export CC CXX
@@ -236,4 +237,3 @@
     endif
     OPT_CFLAGS += $(LTO_CFLAGS)
     OPT_PIE_CFLAGS += $(LTO_CFLAGS)
-    AR=$(DEB_HOST_GNU_TYPE)-gcc-ar

=== debian/tests/control ===
Tests: testsuite
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  libpython3.13-testsuite:native,
  python3.13-gdbm,
  python3.13-tk,
  idle-python3.13,
  systemtap-sdt-dev,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: testsuite-dbg
Depends: build-essential,
  ca-certificates,
  locales-all, python3.13-dev,
  python3.13-dbg,
  libpython3.13-testsuite:native,
  gdb,
  idle-python3.13,
  systemtap-sdt-dev,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  libpython3.13-testsuite:native,
  python3.13-gdbm,
  python3.13-tk,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: failing-tests-dbg
Depends: build-essential,
  ca-certificates,
  locales-all,
  python3.13-dev,
  python3.13-dbg,
  libpython3.13-testsuite:native,
  gdb,
  python3.13-venv,
# need to turn off apport
Restrictions: needs-root, allow-stderr

Tests: module-install-local
Depends: build-essential,
  python3.13-dev,
  python3-pip,
  python3-setuptools,
  shunit2,
Restrictions: needs-root, allow-stderr

Tests: module-install-user
Depends: build-essential,
  python3.13-dev,
  python3-pip,
  python3-setuptools,
  shunit2
Restrictions: allow-stderr

Tests: module-install-venv
Depends: build-essential,
  python3.13-dev,
  python3.13-venv,
  python3-setuptools-whl (>= 70.1),
  shunit2
Restrictions: allow-stderr

Tests: module-install-virtualenv
Depends: build-essential,
  python3.13-dev,
  shunit2,
  virtualenv,
  python3-setuptools-whl (>= 70.1)
Restrictions: allow-stderr

=== debian/watch ===
version=4
opts=dversionmangle=s/.*\+//,\
  uversionmangle=s/([abcr]+[1-9])$/~$1/ \
  http://www.python.org/ftp/python/3\.14(\.\d)?/Python-(3\.14[.\dabcr]*)\.tar.xz
